#ifndef _DECL_sim_H_
#define _DECL_sim_H_
#include "charm++.h"
#include "ldbal.decl.h"

#include "gvt.decl.h"

#include "mempool.decl.h"

#include "memory_temporal.decl.h"

#include "stats.decl.h"

/* DECLS: readonly CProxy_sim POSE_Objects;
 */

/* DECLS: readonly CProxy_sim POSE_Objects_RO;
 */

/* DECLS: readonly CkChareID POSE_Coordinator_ID;
 */

/* DECLS: message eventMsg;
 */
class eventMsg;
class CMessage_eventMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_eventMsg();
    static void *pack(eventMsg *p);
    static eventMsg* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, dealloc, size);
    }
};

/* DECLS: message cancelMsg;
 */
class cancelMsg;
class CMessage_cancelMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_cancelMsg();
    static void *pack(cancelMsg *p);
    static cancelMsg* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, dealloc, size);
    }
};

/* DECLS: message prioMsg;
 */
class prioMsg;
class CMessage_prioMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_prioMsg();
    static void *pack(prioMsg *p);
    static prioMsg* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, dealloc, size);
    }
};

/* DECLS: message destMsg;
 */
class destMsg;
class CMessage_destMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_destMsg();
    static void *pack(destMsg *p);
    static destMsg* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, dealloc, size);
    }
};

/* DECLS: array sim: ArrayElement{
sim(CkMigrateMessage* impl_msg);
sim(void);
void Step(void);
void Step(prioMsg* impl_msg);
void CheckpointStep(eventMsg* impl_msg);
void Status(void);
void Commit(void);
void CheckpointCommit(void);
void ReportLBdata(void);
void Migrate(destMsg* impl_msg);
void Terminate(void);
void Cancel(cancelMsg* impl_msg);
void SeqBeginCheckpoint(void);
void SeqResumeAfterCheckpoint(void);
void invokeStopEvent(void);
void setSimulationStartGVT(const POSE_TimeType &impl_noname_0);
};
 */
 class sim;
 class CkIndex_sim;
 class CProxy_sim;
 class CProxyElement_sim;
 class CProxySection_sim;
/* --------------- index object ------------------ */
class CkIndex_sim:public CProxyElement_ArrayElement{
  public:
    typedef sim local_t;
    typedef CkIndex_sim index_t;
    typedef CProxy_sim proxy_t;
    typedef CProxyElement_sim element_t;
    typedef CProxySection_sim section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: sim(CkMigrateMessage* impl_msg);
 */
    static int __idx_sim_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_sim_CkMigrateMessage; }
    static void _call_sim_CkMigrateMessage(void* impl_msg,sim* impl_obj);

/* DECLS: sim(void);
 */
    static int __idx_sim_void;
    static int ckNew(void) { return __idx_sim_void; }
    static void _call_sim_void(void* impl_msg,sim* impl_obj);

/* DECLS: void Step(void);
 */
    static int __idx_Step_void;
    static int Step(void) { return __idx_Step_void; }
    static void _call_Step_void(void* impl_msg,sim* impl_obj);

/* DECLS: void Step(prioMsg* impl_msg);
 */
    static int __idx_Step_prioMsg;
    static int Step(prioMsg* impl_msg) { return __idx_Step_prioMsg; }
    static void _call_Step_prioMsg(void* impl_msg,sim* impl_obj);

/* DECLS: void CheckpointStep(eventMsg* impl_msg);
 */
    static int __idx_CheckpointStep_eventMsg;
    static int CheckpointStep(eventMsg* impl_msg) { return __idx_CheckpointStep_eventMsg; }
    static void _call_CheckpointStep_eventMsg(void* impl_msg,sim* impl_obj);

/* DECLS: void Status(void);
 */
    static int __idx_Status_void;
    static int Status(void) { return __idx_Status_void; }
    static void _call_Status_void(void* impl_msg,sim* impl_obj);

/* DECLS: void Commit(void);
 */
    static int __idx_Commit_void;
    static int Commit(void) { return __idx_Commit_void; }
    static void _call_Commit_void(void* impl_msg,sim* impl_obj);

/* DECLS: void CheckpointCommit(void);
 */
    static int __idx_CheckpointCommit_void;
    static int CheckpointCommit(void) { return __idx_CheckpointCommit_void; }
    static void _call_CheckpointCommit_void(void* impl_msg,sim* impl_obj);

/* DECLS: void ReportLBdata(void);
 */
    static int __idx_ReportLBdata_void;
    static int ReportLBdata(void) { return __idx_ReportLBdata_void; }
    static void _call_ReportLBdata_void(void* impl_msg,sim* impl_obj);

/* DECLS: void Migrate(destMsg* impl_msg);
 */
    static int __idx_Migrate_destMsg;
    static int Migrate(destMsg* impl_msg) { return __idx_Migrate_destMsg; }
    static void _call_Migrate_destMsg(void* impl_msg,sim* impl_obj);

/* DECLS: void Terminate(void);
 */
    static int __idx_Terminate_void;
    static int Terminate(void) { return __idx_Terminate_void; }
    static void _call_Terminate_void(void* impl_msg,sim* impl_obj);

/* DECLS: void Cancel(cancelMsg* impl_msg);
 */
    static int __idx_Cancel_cancelMsg;
    static int Cancel(cancelMsg* impl_msg) { return __idx_Cancel_cancelMsg; }
    static void _call_Cancel_cancelMsg(void* impl_msg,sim* impl_obj);

/* DECLS: void SeqBeginCheckpoint(void);
 */
    static int __idx_SeqBeginCheckpoint_void;
    static int SeqBeginCheckpoint(void) { return __idx_SeqBeginCheckpoint_void; }
    static void _call_SeqBeginCheckpoint_void(void* impl_msg,sim* impl_obj);

/* DECLS: void SeqResumeAfterCheckpoint(void);
 */
    static int __idx_SeqResumeAfterCheckpoint_void;
    static int SeqResumeAfterCheckpoint(void) { return __idx_SeqResumeAfterCheckpoint_void; }
    static void _call_SeqResumeAfterCheckpoint_void(void* impl_msg,sim* impl_obj);

/* DECLS: void invokeStopEvent(void);
 */
    static int __idx_invokeStopEvent_void;
    static int invokeStopEvent(void) { return __idx_invokeStopEvent_void; }
    static void _call_invokeStopEvent_void(void* impl_msg,sim* impl_obj);

/* DECLS: void setSimulationStartGVT(const POSE_TimeType &impl_noname_0);
 */
    static int __idx_setSimulationStartGVT_marshall15;
    static int setSimulationStartGVT(const POSE_TimeType &impl_noname_0) { return __idx_setSimulationStartGVT_marshall15; }
    static void _call_setSimulationStartGVT_marshall15(void* impl_msg,sim* impl_obj);
    static int _callmarshall_setSimulationStartGVT_marshall15(char* impl_buf,sim* impl_obj);
    static void _marshallmessagepup_setSimulationStartGVT_marshall15(PUP::er &p,void *msg);

};
/* --------------- element proxy ------------------ */
 class CProxyElement_sim : public CProxyElement_ArrayElement{
  public:
    typedef sim local_t;
    typedef CkIndex_sim index_t;
    typedef CProxy_sim proxy_t;
    typedef CProxyElement_sim element_t;
    typedef CProxySection_sim section_t;

    CProxyElement_sim(void) {}
    CProxyElement_sim(const ArrayElement *e) : CProxyElement_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_ArrayElement::pup(p);
    }
int ckIsDelegated(void) const {return CProxyElement_ArrayElement::ckIsDelegated();}
inline CkDelegateMgr *ckDelegatedTo(void) const {return CProxyElement_ArrayElement::ckDelegatedTo();}
inline CkDelegateData *ckDelegatedPtr(void) const {return CProxyElement_ArrayElement::ckDelegatedPtr();}
CkGroupID ckDelegatedIdx(void) const {return CProxyElement_ArrayElement::ckDelegatedIdx();}
inline void ckCheck(void) const {CProxyElement_ArrayElement::ckCheck();}
inline operator CkArrayID () const {return ckGetArrayID();}
inline static CkArrayID ckCreateEmptyArray(void){ return CProxyElement_ArrayElement::ckCreateEmptyArray(); }
inline static CkArrayID ckCreateArray(CkArrayMessage *m,int ctor,const CkArrayOptions &opts){ return CProxyElement_ArrayElement::ckCreateArray(m,ctor,opts); }
inline void ckInsertIdx(CkArrayMessage *m,int ctor,int onPe,const CkArrayIndex &idx){ CProxyElement_ArrayElement::ckInsertIdx(m,ctor,onPe,idx); }
inline void ckBroadcast(CkArrayMessage *m, int ep, int opts=0) const{ CProxyElement_ArrayElement::ckBroadcast(m,ep,opts); }
inline CkArrayID ckGetArrayID(void) const{ return CProxyElement_ArrayElement::ckGetArrayID();}
inline CkArray *ckLocalBranch(void) const{ return CProxyElement_ArrayElement::ckLocalBranch(); }
inline CkLocMgr *ckLocMgr(void) const{ return CProxyElement_ArrayElement::ckLocMgr(); }
inline void doneInserting(void) { CProxyElement_ArrayElement::doneInserting(); }
inline void setReductionClient(CkReductionClientFn fn,void *param=NULL) const
{ CProxyElement_ArrayElement::setReductionClient(fn,param); }
inline void ckSetReductionClient(CkReductionClientFn fn,void *param=NULL) const
{ CProxyElement_ArrayElement::ckSetReductionClient(fn,param); }
inline void ckSetReductionClient(CkCallback *cb) const
{ CProxyElement_ArrayElement::ckSetReductionClient(cb); }
inline void ckInsert(CkArrayMessage *m,int ctor,int onPe)
  { CProxyElement_ArrayElement::ckInsert(m,ctor,onPe); }
inline void ckSend(CkArrayMessage *m, int ep, int opts = 0) const
  { CProxyElement_ArrayElement::ckSend(m,ep,opts); }
inline void *ckSendSync(CkArrayMessage *m, int ep) const
  { return CProxyElement_ArrayElement::ckSendSync(m,ep); }
inline const CkArrayIndex &ckGetIndex() const
  { return CProxyElement_ArrayElement::ckGetIndex(); }
    sim *ckLocal(void) const
      { return (sim *)CProxyElement_ArrayElement::ckLocal(); }
    CProxyElement_sim(const CkArrayID &aid,const CkArrayIndex1D &idx,CK_DELCTOR_PARAM)
        :CProxyElement_ArrayElement(aid,idx,CK_DELCTOR_ARGS) {}
    CProxyElement_sim(const CkArrayID &aid,const CkArrayIndex1D &idx)
        :CProxyElement_ArrayElement(aid,idx) {}
/* DECLS: sim(CkMigrateMessage* impl_msg);
 */

/* DECLS: sim(void);
 */
    void insert(int onPE=-1);
/* DECLS: void Step(void);
 */
    void Step(void) ;

/* DECLS: void Step(prioMsg* impl_msg);
 */
    void Step(prioMsg* impl_msg) ;

/* DECLS: void CheckpointStep(eventMsg* impl_msg);
 */
    void CheckpointStep(eventMsg* impl_msg) ;

/* DECLS: void Status(void);
 */
    void Status(void) ;

/* DECLS: void Commit(void);
 */
    void Commit(void) ;

/* DECLS: void CheckpointCommit(void);
 */
    void CheckpointCommit(void) ;

/* DECLS: void ReportLBdata(void);
 */
    void ReportLBdata(void) ;

/* DECLS: void Migrate(destMsg* impl_msg);
 */
    void Migrate(destMsg* impl_msg) ;

/* DECLS: void Terminate(void);
 */
    void Terminate(void) ;

/* DECLS: void Cancel(cancelMsg* impl_msg);
 */
    void Cancel(cancelMsg* impl_msg) ;

/* DECLS: void SeqBeginCheckpoint(void);
 */
    void SeqBeginCheckpoint(void) ;

/* DECLS: void SeqResumeAfterCheckpoint(void);
 */
    void SeqResumeAfterCheckpoint(void) ;

/* DECLS: void invokeStopEvent(void);
 */
    void invokeStopEvent(void) ;

/* DECLS: void setSimulationStartGVT(const POSE_TimeType &impl_noname_0);
 */
    void setSimulationStartGVT(const POSE_TimeType &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL) ;

};
PUPmarshall(CProxyElement_sim)
/* ---------------- collective proxy -------------- */
 class CProxy_sim : public CProxy_ArrayElement{
  public:
    typedef sim local_t;
    typedef CkIndex_sim index_t;
    typedef CProxy_sim proxy_t;
    typedef CProxyElement_sim element_t;
    typedef CProxySection_sim section_t;

    CProxy_sim(void) {}
    CProxy_sim(const ArrayElement *e) : CProxy_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_ArrayElement::pup(p);
    }
int ckIsDelegated(void) const {return CProxy_ArrayElement::ckIsDelegated();}
inline CkDelegateMgr *ckDelegatedTo(void) const {return CProxy_ArrayElement::ckDelegatedTo();}
inline CkDelegateData *ckDelegatedPtr(void) const {return CProxy_ArrayElement::ckDelegatedPtr();}
CkGroupID ckDelegatedIdx(void) const {return CProxy_ArrayElement::ckDelegatedIdx();}
inline void ckCheck(void) const {CProxy_ArrayElement::ckCheck();}
inline operator CkArrayID () const {return ckGetArrayID();}
inline static CkArrayID ckCreateEmptyArray(void){ return CProxy_ArrayElement::ckCreateEmptyArray(); }
inline static CkArrayID ckCreateArray(CkArrayMessage *m,int ctor,const CkArrayOptions &opts){ return CProxy_ArrayElement::ckCreateArray(m,ctor,opts); }
inline void ckInsertIdx(CkArrayMessage *m,int ctor,int onPe,const CkArrayIndex &idx){ CProxy_ArrayElement::ckInsertIdx(m,ctor,onPe,idx); }
inline void ckBroadcast(CkArrayMessage *m, int ep, int opts=0) const{ CProxy_ArrayElement::ckBroadcast(m,ep,opts); }
inline CkArrayID ckGetArrayID(void) const{ return CProxy_ArrayElement::ckGetArrayID();}
inline CkArray *ckLocalBranch(void) const{ return CProxy_ArrayElement::ckLocalBranch(); }
inline CkLocMgr *ckLocMgr(void) const{ return CProxy_ArrayElement::ckLocMgr(); }
inline void doneInserting(void) { CProxy_ArrayElement::doneInserting(); }
inline void setReductionClient(CkReductionClientFn fn,void *param=NULL) const
{ CProxy_ArrayElement::setReductionClient(fn,param); }
inline void ckSetReductionClient(CkReductionClientFn fn,void *param=NULL) const
{ CProxy_ArrayElement::ckSetReductionClient(fn,param); }
inline void ckSetReductionClient(CkCallback *cb) const
{ CProxy_ArrayElement::ckSetReductionClient(cb); }
    static CkArrayID ckNew(void) {return ckCreateEmptyArray();}
//Generalized array indexing:
    CProxyElement_sim operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_sim(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_sim operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_sim(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_sim operator [] (int idx) const 
        {return CProxyElement_sim(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxyElement_sim operator () (int idx) const 
        {return CProxyElement_sim(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxy_sim(const CkArrayID &aid,CK_DELCTOR_PARAM) 
        :CProxy_ArrayElement(aid,CK_DELCTOR_ARGS) {}
    CProxy_sim(const CkArrayID &aid) 
        :CProxy_ArrayElement(aid) {}
/* DECLS: sim(CkMigrateMessage* impl_msg);
 */

/* DECLS: sim(void);
 */
    static CkArrayID ckNew(const CkArrayOptions &opts);
    static CkArrayID ckNew(const int s1);

/* DECLS: void Step(void);
 */
    void Step(void) ;

/* DECLS: void Step(prioMsg* impl_msg);
 */
    void Step(prioMsg* impl_msg) ;

/* DECLS: void CheckpointStep(eventMsg* impl_msg);
 */
    void CheckpointStep(eventMsg* impl_msg) ;

/* DECLS: void Status(void);
 */
    void Status(void) ;

/* DECLS: void Commit(void);
 */
    void Commit(void) ;

/* DECLS: void CheckpointCommit(void);
 */
    void CheckpointCommit(void) ;

/* DECLS: void ReportLBdata(void);
 */
    void ReportLBdata(void) ;

/* DECLS: void Migrate(destMsg* impl_msg);
 */
    void Migrate(destMsg* impl_msg) ;

/* DECLS: void Terminate(void);
 */
    void Terminate(void) ;

/* DECLS: void Cancel(cancelMsg* impl_msg);
 */
    void Cancel(cancelMsg* impl_msg) ;

/* DECLS: void SeqBeginCheckpoint(void);
 */
    void SeqBeginCheckpoint(void) ;

/* DECLS: void SeqResumeAfterCheckpoint(void);
 */
    void SeqResumeAfterCheckpoint(void) ;

/* DECLS: void invokeStopEvent(void);
 */
    void invokeStopEvent(void) ;

/* DECLS: void setSimulationStartGVT(const POSE_TimeType &impl_noname_0);
 */
    void setSimulationStartGVT(const POSE_TimeType &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL) ;

};
PUPmarshall(CProxy_sim)
/* ---------------- section proxy -------------- */
 class CProxySection_sim : public CProxySection_ArrayElement{
  public:
    typedef sim local_t;
    typedef CkIndex_sim index_t;
    typedef CProxy_sim proxy_t;
    typedef CProxyElement_sim element_t;
    typedef CProxySection_sim section_t;

    CProxySection_sim(void) {}
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxySection_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxySection_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxySection_ArrayElement::pup(p);
    }
int ckIsDelegated(void) const {return CProxySection_ArrayElement::ckIsDelegated();}
inline CkDelegateMgr *ckDelegatedTo(void) const {return CProxySection_ArrayElement::ckDelegatedTo();}
inline CkDelegateData *ckDelegatedPtr(void) const {return CProxySection_ArrayElement::ckDelegatedPtr();}
CkGroupID ckDelegatedIdx(void) const {return CProxySection_ArrayElement::ckDelegatedIdx();}
inline void ckCheck(void) const {CProxySection_ArrayElement::ckCheck();}
inline operator CkArrayID () const {return ckGetArrayID();}
inline static CkArrayID ckCreateEmptyArray(void){ return CProxySection_ArrayElement::ckCreateEmptyArray(); }
inline static CkArrayID ckCreateArray(CkArrayMessage *m,int ctor,const CkArrayOptions &opts){ return CProxySection_ArrayElement::ckCreateArray(m,ctor,opts); }
inline void ckInsertIdx(CkArrayMessage *m,int ctor,int onPe,const CkArrayIndex &idx){ CProxySection_ArrayElement::ckInsertIdx(m,ctor,onPe,idx); }
inline void ckBroadcast(CkArrayMessage *m, int ep, int opts=0) const{ CProxySection_ArrayElement::ckBroadcast(m,ep,opts); }
inline CkArrayID ckGetArrayID(void) const{ return CProxySection_ArrayElement::ckGetArrayID();}
inline CkArray *ckLocalBranch(void) const{ return CProxySection_ArrayElement::ckLocalBranch(); }
inline CkLocMgr *ckLocMgr(void) const{ return CProxySection_ArrayElement::ckLocMgr(); }
inline void doneInserting(void) { CProxySection_ArrayElement::doneInserting(); }
inline void setReductionClient(CkReductionClientFn fn,void *param=NULL) const
{ CProxySection_ArrayElement::setReductionClient(fn,param); }
inline void ckSetReductionClient(CkReductionClientFn fn,void *param=NULL) const
{ CProxySection_ArrayElement::ckSetReductionClient(fn,param); }
inline void ckSetReductionClient(CkCallback *cb) const
{ CProxySection_ArrayElement::ckSetReductionClient(cb); }
inline void ckSend(CkArrayMessage *m, int ep, int opts = 0)
 { CProxySection_ArrayElement::ckSend(m,ep,opts); }
inline CkSectionInfo &ckGetSectionInfo()
  { return CProxySection_ArrayElement::ckGetSectionInfo(); }
inline CkSectionID *ckGetSectionIDs()
  { return CProxySection_ArrayElement::ckGetSectionIDs(); }
inline CkSectionID &ckGetSectionID()
  { return CProxySection_ArrayElement::ckGetSectionID(); }
inline CkSectionID &ckGetSectionID(int i)
  { return CProxySection_ArrayElement::ckGetSectionID(i); }
inline CkArrayID ckGetArrayIDn(int i) const
{return CProxySection_ArrayElement::ckGetArrayIDn(i); } 
inline CkArrayIndexMax *ckGetArrayElements() const
  { return CProxySection_ArrayElement::ckGetArrayElements(); }
inline CkArrayIndexMax *ckGetArrayElements(int i) const
{return CProxySection_ArrayElement::ckGetArrayElements(i); }
inline int ckGetNumElements() const
  { return CProxySection_ArrayElement::ckGetNumElements(); } 
inline int ckGetNumElements(int i) const
{return CProxySection_ArrayElement::ckGetNumElements(i); } 
//Generalized array indexing:
    CProxyElement_sim operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_sim(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_sim operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_sim(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_sim operator [] (int idx) const 
        {return CProxyElement_sim(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    CProxyElement_sim operator () (int idx) const 
        {return CProxyElement_sim(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndex1D *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
    static CkSectionID ckNew(const CkArrayID &aid, int l, int u, int s) {
      CkVec<CkArrayIndex1D> al;
      for (int i=l; i<=u; i+=s) al.push_back(CkArrayIndex1D(i));
      return CkSectionID(aid, al.getVec(), al.size());
    } 
    CProxySection_sim(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems, CK_DELCTOR_PARAM) 
        :CProxySection_ArrayElement(aid,elems,nElems,CK_DELCTOR_ARGS) {}
    CProxySection_sim(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) 
        :CProxySection_ArrayElement(aid,elems,nElems) {}
    CProxySection_sim(const CkSectionID &sid)       :CProxySection_ArrayElement(sid) {}
    CProxySection_sim(int n, const CkArrayID *aid, CkArrayIndexMax const * const *elems, const int *nElems, CK_DELCTOR_PARAM) 
        :CProxySection_ArrayElement(n,aid,elems,nElems,CK_DELCTOR_ARGS) {}
    CProxySection_sim(int n, const CkArrayID *aid, CkArrayIndexMax const * const *elems, const int *nElems) 
        :CProxySection_ArrayElement(n,aid,elems,nElems) {}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
/* DECLS: sim(CkMigrateMessage* impl_msg);
 */

/* DECLS: sim(void);
 */

/* DECLS: void Step(void);
 */
    void Step(void) ;

/* DECLS: void Step(prioMsg* impl_msg);
 */
    void Step(prioMsg* impl_msg) ;

/* DECLS: void CheckpointStep(eventMsg* impl_msg);
 */
    void CheckpointStep(eventMsg* impl_msg) ;

/* DECLS: void Status(void);
 */
    void Status(void) ;

/* DECLS: void Commit(void);
 */
    void Commit(void) ;

/* DECLS: void CheckpointCommit(void);
 */
    void CheckpointCommit(void) ;

/* DECLS: void ReportLBdata(void);
 */
    void ReportLBdata(void) ;

/* DECLS: void Migrate(destMsg* impl_msg);
 */
    void Migrate(destMsg* impl_msg) ;

/* DECLS: void Terminate(void);
 */
    void Terminate(void) ;

/* DECLS: void Cancel(cancelMsg* impl_msg);
 */
    void Cancel(cancelMsg* impl_msg) ;

/* DECLS: void SeqBeginCheckpoint(void);
 */
    void SeqBeginCheckpoint(void) ;

/* DECLS: void SeqResumeAfterCheckpoint(void);
 */
    void SeqResumeAfterCheckpoint(void) ;

/* DECLS: void invokeStopEvent(void);
 */
    void invokeStopEvent(void) ;

/* DECLS: void setSimulationStartGVT(const POSE_TimeType &impl_noname_0);
 */
    void setSimulationStartGVT(const POSE_TimeType &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL) ;

};
PUPmarshall(CProxySection_sim)
typedef CBaseT1<ArrayElementT<CkIndex1D>, CProxy_sim> CBase_sim;

extern void _registersim(void);
#endif
